`
	mymacdef.mm

	By Ross Ridge
	Public Domain
`	
{bind-lisp-expr `define`
		`'(lambda (value macname &rest args)
		    (let ((macval) (arg))
		      (setq args (nreverse args))
		      (while (prog1 (setq arg (car args))
			       (setq args (cdr args)))
			(if (and (stringp arg) (stringp (car macval)))
			    (setcar macval (concat arg (car macval)))
			  (setq macval (cons arg macval))))
		      (if (or (integerp (car macval))
			      (cdr macval))
			  (mymac-define-macro macname macval
					      'mymac-define-expand)
			(mymac-define-macro macname (car macval)))))`
		`*define*` `optimize`}

{define mymacdef-ident `@(#) mymac mymacdef.mm 2.2 95/04/09 02:55:57`}

{bind-lisp-expr `undef`
		`'(lambda (value macname)
		    (let ((macsym (intern-soft macname mymac-obarray)))
		      (if macsym
			  (fmakunbound macsym))
		      nil))`}

{bind-lisp-expr `include`
		`'(lambda (value filename)
		    (let ((obtmp mymac-obarray)
			  (syntax (syntax-table)))
		      (save-excursion
			(set-buffer (generate-new-buffer "*mymac include*"))
			(insert-file-contents 
			 (mymac-search-path filename (cons nil load-path)))
;;;			(make-local-variable 'mymac-obarray)
;;;			(setq mymac-obarray obtmp)
;;;			(set-syntax-table syntax)
;;;			(mymac-expand-region (point-min) (point-max))
			(prog1
			    (buffer-string)
			  (kill-buffer (current-buffer))))))`
		} {`*include*` `optimize`}

{bind-lisp-expr `ignore` `'ignore`}

{bind-lisp-expr `upcase` `'(mapconcat 'upcase args " ")`}

{bind-lisp-expr `downcase` `'(mapconcat 'downcase args " ")`}

{bind-lisp-expr `foreach`
		`'(lambda (value macname seperator &rest args)
		    (let ((macsym (intern-soft macname mymac-obarray))
			  (macfn) (macval))
		      (if macsym
			  (progn
			    (setq macval (symbol-value macsym))
			    (setq macfn (symbol-function macsym))
			    (mapconcat '(lambda (arg)
					  (setq arg (funcall macfn macval arg))
					  (if (stringp arg)
					      arg
					    ""))
				       args seperator)))))`
		`*foreach*` `optimize`}

{bind-lisp-expr `sort` `'(mapconcat 'identity (sort args 'string<) " ")`}

{bind-lisp-expr `uniq` `'(let ((prev ""))
			   (mapconcat (function (lambda (arg)
						  (if (string-equal arg prev)
						      ""
						    (setq prev arg))))
				      args " "))`
		`*uniq*` `optimize`}

{bind-lisp-expr `quote` `'(mymac-quote-string 
			   (mapconcat 'identity args ""))`}


